/*************************************************
 **                                             **
 **   hi_level.c                                **
 **                                             **
 **       sample higher level functions         **
 **                                             **
 **       Copyright (C) 1991 by                 **
 **               SoftC, Ltd.                   **
 **               16820 Third Street NE         **
 **               Anoka, MN 55304               **
 **               (612) 434-6968                **
 **                                             **
 **             All rights reserved.            **
 *************************************************/


#include <string.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include "hi_level.h"


/*
 * definitions
 */

#ifdef DBASE3
#define INDEX_EXPR scdnexpr(cp->handle,xpr)
#define OPEN_INDEX scdnopenx(&(cp->handle),cp->name,cp->mode)
#define UNLOCK_INDEX scdnunlock(cp->handle)
#define LOCK_INDEX scdnlock(cp->handle)
#define CLOSE_INDEX scdnclose(cp->handle)
#define FIND_KEY scdnkfind(cp->handle,key_pntr,&daccess->recno,SC_FIRST)
#define MAKE_KEY scdnkmake(daccess->handle,cp->handle,(void **)&key_pntr)
#define MAKE_NKEY scdnknum(tempstring,(DOUBLE) *key_pntr)
#define MAKE_DKEY scdnkdate(tempstring,key_pntr,datestyle)
#define NEXT_KEY scdnknext(cp->handle,key_pntr,recno)
#define PREVIOUS_KEY scdnkprev(cp->handle,key_pntr,recno)
#define ADD_KEY scdnkadd(cp->handle,key_pntr,recno)
#define DELETE_KEY scdnkdel(cp->handle,key_pntr,recno)
#endif
#ifdef DBASE4
#define OPEN_INDEX scdmopenx(&(cp->handle),cp->name,cp->mode)
#define UNLOCK_INDEX scdmunlock(cp->handle)
#define LOCK_INDEX scdmlock(cp->handle)
#define CLOSE_INDEX scdmclose(cp->handle)
#define FIND_KEY scdmkfind(ct->handle,key_pntr,&daccess->recno,SC_FIRST)
#define MAKE_KEY scdmkmake(daccess->handle,ct->handle,(void **)&key_pntr)
#define MAKE_NKEY scdmknum(tempstring,(DOUBLE) *key_pntr)
#define MAKE_DKEY scdmkdate(tempstring,key_pntr,datestyle)
#define NEXT_KEY scdmknext(ct->handle,key_pntr,recno)
#define PREVIOUS_KEY scdmkprev(ct->handle,key_pntr,recno)
#define ADD_KEY scdmkadd(ct->handle,key_pntr,recno)
#define DELETE_KEY scdmkdel(ct->handle,key_pntr,recno)
#endif
#ifdef FoxBASE
#define INDEX_EXPR scdiexpr(cp->handle,xpr)
#define OPEN_INDEX scdiopenx(&(cp->handle),cp->name,cp->mode)
#define UNLOCK_INDEX scdiunlock(cp->handle)
#define LOCK_INDEX scdilock(cp->handle)
#define CLOSE_INDEX scdiclose(cp->handle)
#define FIND_KEY scdikfind(cp->handle,key_pntr,&daccess->recno,SC_FIRST)
#define MAKE_KEY scdikmake(daccess->handle,cp->handle,(void **)&key_pntr)
#define MAKE_NKEY scdiknum(tempstring,(DOUBLE) *key_pntr)
#define MAKE_DKEY scdikdate(tempstring,key_pntr,datestyle)
#define NEXT_KEY scdiknext(cp->handle,key_pntr,recno)
#define PREVIOUS_KEY scdikprev(cp->handle,key_pntr,recno)
#define ADD_KEY scdikadd(cp->handle,key_pntr,recno)
#define DELETE_KEY scdikdel(cp->handle,key_pntr,recno)
#endif
#ifdef Clipper
#define INDEX_EXPR scdcexpr(cp->handle,xpr)
#define OPEN_INDEX scdcopenx(&(cp->handle),cp->name,cp->mode)
#define UNLOCK_INDEX scdcunlock(cp->handle)
#define LOCK_INDEX scdclock(cp->handle)
#define CLOSE_INDEX scdcclose(cp->handle)
#define FIND_KEY scdckfind(cp->handle,key_pntr,&daccess->recno,SC_FIRST)
#define MAKE_KEY scdckmake(daccess->handle,cp->handle,(void **)&key_pntr)
#define MAKE_NKEY scdcknum(cp->handle,tempstring,(DOUBLE) *key_pntr)
#define MAKE_DKEY scdckdate(tempstring,key_pntr,datestyle)
#define NEXT_KEY scdcknext(cp->handle,key_pntr,recno)
#define PREVIOUS_KEY scdckprev(cp->handle,key_pntr,recno)
#define ADD_KEY scdckadd(cp->handle,key_pntr,recno)
#define DELETE_KEY scdckdel(cp->handle,key_pntr,recno)
#endif


static struct DATA_PKT *db_start = (struct DATA_PKT *)NULL;
static INT savestat;
CHAR db3_error_message_display = 0;

/*
 * internal prototype
 */

#ifdef __ANSI_PROTOTYPES__
static INT writefield(struct DATA_PKT *, CHAR *, CHAR *, INT);
#else
static INT writefield();
#endif

/*******************************************************************
 **                                                               **
 **     Function:       ltrim                                     **
 **     Prototype:      CHAR *ltrim(                              **
 **         CHAR *);            source character string           **
 **     Purpose:        To left justify a character string        **
 **         (remove leading spaces).                              **
 **	Return Values:                                            **
 **		pointer to trimmed string                         **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
CHAR *ltrim(CHAR *string)
#else
CHAR *ltrim(string)
CHAR *string;
#endif
{
  INT count1= 0, count2 = 0;

  if (string[0] == ' ') {
    while (string[count1] == ' ')
      ++count1;
    do {
      string[count2] = string[count1];
      ++count1; ++count2;
    } while (string[count1] != 0);
    string[count2] = 0;
  }
  return(string);
}  /* ltrim */


/*******************************************************************
 **                                                               **
 **     Function:       status_display                            **
 **     Prototype:      VOID status_display(                      **
 **         CHAR *);            character string to be displayed  **
 **     Purpose:        To display a character string.            **
 **	Return Values:                                            **
 **		none                                              **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
VOID status_display(CHAR *string)
#else
VOID status_display(string)
CHAR *string;
#endif
{
  FILE *file;

  if (db3error_message_display != 0) {
    file = fopen("DEBUG.OUT","at");
    fprintf(file," %s STAT=%d ERCD=%d\n",string,savestat,scecode());
    fclose(file);
  }
}  /* status_display */


/*******************************************************************
 **                                                               **
 **     Function:       get_status                                **
 **     Prototype:      INT get_status( VOID );                   **
 **     Purpose:        To return the status of the last command  **
 **         executed.                                             **
 **	Return Values:                                            **
 **		status of last function executed                  **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
INT get_status(VOID)
#else
INT get_status()
#endif
{
  return(savestat);
}  /* get_status */


/*******************************************************************
 **                                                               **
 **     Function:       sc_use                                    **
 **     Prototype:      struct DATA_PKT *sc_use(                  **
 **         CHAR *,		data file name                    **
 **         INT,    		open mode                         **
 **         INT, 		number of indices to open         **
 **         ... );		names of index files to be opened **
 **     Purpose:        To open a data file and create structures **
 **         to control & update data and index files. See 	  **
 **         scddopenx for possible values for 'mode'.             **
 **	Return Values:                                            **
 **		pointer to data file packet if successful         **
 **		NULL if could not complete open                   **
 **                                                               **
 *******************************************************************/

struct DATA_PKT *sc_use(CHAR *dbf_name, INT mode, INT num_indices, ... )
{
  CHAR tempstr[80], *p1;
  struct DATA_PKT *tp, *cp;
  SC_DBFRINFO rinfo;
  INT dummy;
  va_list argptr;

/* see if data file structure already exists */
  tp = db_start;
  while (tp != NULL && strcmp(dbf_name,tp->name) != 0)
    tp = tp->next_file;
  if (tp != NULL) {
  /* it already exists */
    sprintf(tempstr,"%s file already open",tp->name);
    status_display(tempstr);
    return(NULL);
  }

/* create the structure */
  if ((cp = (struct DATA_PKT *)malloc(sizeof(struct DATA_PKT))) == NULL) {
    status_display("Unable to aquire memory");
    return(NULL);
  }

/* initialize some variables */
  cp->next_file = NULL;
  cp->recno = 0l;
  cp->index = NULL;
#ifdef DBASE3
  cp->mode = mode | SC_DB3;
#endif
#ifdef DBASE4
  cp->mode = mode | SC_DB4;
#endif
#ifdef FoxBASE
  cp->mode = mode | SC_FB;
#endif
#ifdef Clipper
  cp->mode = mode | SC_CLIP5;
#endif
  strcpy(cp->name,dbf_name);

/* open data file */
  savestat=scddopenx(&(cp->handle),cp->name, cp->mode );
  if (savestat !=SC_SUCCESS) {
    sprintf(tempstr,"Unable to open %s file ",cp->name);
    status_display(tempstr);
    free(cp);
    return(NULL);
  }

/* get data file information */
  savestat=scddrinfo(cp->handle,&rinfo);
  if (savestat != SC_SUCCESS) {
    sprintf(tempstr,"Unable to get %s file info",cp->name);
    status_display(tempstr);
    scddclose(cp->handle);
    free(cp);
    return(NULL);
  }
  cp->reclngth = rinfo.reclen;
  cp->nbr_fields = rinfo.numflds;

/* allocate memory for field descriptions */
  if ((cp->fields = (SC_FIELD *)malloc(cp->nbr_fields * sizeof(SC_FIELD))) == NULL) {
    status_display("Unable to allocate memory for field descriptions");
    scddclose(cp->handle);
    free(cp);
    return(NULL);
  }

/* get field descriptions */
  savestat=scddfinfo(cp->handle,&dummy,cp->fields);
  if (savestat != SC_SUCCESS) {
    status_display("Unable to get field descriptions");
    scddclose(cp->handle);
    free(cp->fields);
    free(cp);
    return(NULL);
  }

/* thread structure into linked list */
  if (db_start == NULL)
    db_start = cp;
  else {
    tp = db_start;
    while (tp->next_file != NULL) tp=tp->next_file;
    tp->next_file=cp;
  }

/* build filename for primary index file */
  strcpy(tempstr,dbf_name);
  if ((p1 = strrchr(tempstr,'.')) == NULL)
    p1 = tempstr + strlen(tempstr);
#ifdef DBASE3
  strcpy(p1,".NDX");
#endif
#ifdef DBASE4
  strcpy(p1,".MDX");
#endif
#ifdef FoxBASE
  strcpy(p1,".IDX");
#endif
#ifdef Clipper
  strcpy(p1,".NTX");
#endif

/* open the primary index file */
  openindex(cp,tempstr,mode);

/* open secondary index files */
  if (num_indices > 0) {
    va_start(argptr,num_indices);
    for (dummy=0;dummy<num_indices;dummy++)
      openindex(cp,va_arg(argptr,char *),mode);
    va_end(argptr);
  }

  return(cp);
}  /* sc_use */


/*******************************************************************
 **                                                               **
 **     Function:       closefile                                 **
 **     Prototype:      INT closefile(                            **
 **        struct DATA_PKT *);   pointer to data packet           **
 **     Purpose:        To close a data file & associated index   **
 **        files and release structures.                          **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
INT closefile(struct DATA_PKT *daccess)
#else
INT closefile(daccess)
struct DATA_PKT *daccess;
#endif
{
  CHAR tempstr[60];
  struct DATA_PKT *dtp;
  struct INDEX_PKT *itp, *cp;

  if (daccess->handle > -1) {
    savestat=scddclose(daccess->handle); /* close data file if open */
    if (savestat != SC_SUCCESS) {
      sprintf(tempstr,"Unable to close %s file ",daccess->name);
      status_display(tempstr);
      return(savestat);
    }
    free(daccess->fields);
  }

/* close and release existing index files for data file */
  cp=daccess->index;
  while (cp != NULL) {
    itp = cp->next_index;
    savestat = CLOSE_INDEX;
    if (savestat != SC_SUCCESS) {
      sprintf(tempstr,"Unable to close %s file",cp->name);
      status_display(tempstr);
      return(savestat);
    }
    free(cp);
    cp=itp;
  }

/* unthread structure from list */
  if (db_start == daccess)
    db_start = daccess->next_file;
  else {
    dtp=db_start;
    while (dtp->next_file != daccess)
      dtp=dtp->next_file;
    dtp->next_file = dtp->next_file->next_file;
  }

/* free structure */
  free(daccess);
  return(savestat);
}  /* closefile */

/*******************************************************************
 **                                                               **
 **     Function:       close_everything                          **
 **     Prototype:      INT close_everything();                   **
 **     Purpose:        To close all open data and index files    **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
INT close_everything(VOID)
#else
INT close_everything()
#endif
{
  struct DATA_PKT *dbtp, *dbnext_pntr;
  INT tempstat, fnlstat;

  fnlstat=SC_SUCCESS;
  dbtp=db_start;
  while (dbtp != NULL) {
    dbnext_pntr=dbtp->next_file;
    tempstat=closefile(dbtp);
    if (tempstat != SC_SUCCESS) fnlstat=tempstat;
    dbtp=dbnext_pntr;
  }
  return(fnlstat);
}  /* close_everything */


/*******************************************************************
 **                                                               **
 **     Function:       openindex                                 **
 **     Prototype:      struct INDEX_PKT *openindex(              **
 **	   struct DATA_PKT *,	data file to link with            **
 **        CHAR *,		index file name                   **
 **        INT );               open mode                         **
 **     Purpose:        To open an index file, allocate & 	  **
 **        initialize a packet, and link it with the data file.   **
 **     Return Values                                             **
 **      	pointer to index file packet or NULL if open      **
 **		was unsuccessful.                                 **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
struct INDEX_PKT *openindex(struct DATA_PKT *daccess,
			    CHAR *ndx_name,
			    INT mode)
#else
struct INDEX_PKT *openindex(daccess,ndx_name,mode)
struct DATA_PKT *daccess;
CHAR *ndx_name;
INT mode;
#endif
{
  CHAR tempstr[60], *xpr;
  struct INDEX_PKT *tp, *cp;
  INT xl;
#ifdef DBASE3
  SC_NDXINFO info;
#endif
#ifdef DBASE4
  struct TAG_PKT *ct, *tt;
  SC_MDXINFO info;
  SC_MDXTINFO tinfo;
  LONG tag;
#endif
#ifdef FoxBASE
  SC_IDXINFO info;
#endif
#ifdef Clipper
  SC_NTXINFO info;
#endif

  tp = daccess->index;
  while (tp != NULL && strcmp(ndx_name,tp->name) != 0)
    tp= tp->next_index;
  if (tp != NULL) {
    sprintf(tempstr,"%s index already open",tp->name);
    status_display(tempstr);
    return(NULL);
  }

/* create the structure */
 if ((cp = (struct INDEX_PKT *)malloc(sizeof(struct INDEX_PKT))) == NULL) {
    status_display("Unable to aquire memory");
    return(NULL);
  }

/* initialize variables */
  cp->mode = mode;
  cp->next_index = NULL;
  strcpy(cp->name,ndx_name);

/* open index file */
  if (OPEN_INDEX != SC_SUCCESS) {
    sprintf(tempstr,"Unable to open %s file",cp->name);
    status_display(tempstr);
    free(cp);
    return(NULL);
  }

/* thread index structure into the index linked list */
  if (daccess->index == NULL)
    daccess->index = cp;
  else {
    tp = daccess->index;
    while (tp->next_index != NULL) tp = tp->next_index;
    tp->next_index = cp;
  }

#ifdef DBASE4
/* get & save some information about index file */
  scdminfo(cp->handle,&info);

/* open all valid index tags */
  xl = 0;
  cp->first_tag = NULL;
  while (xl < info.usedtags) {
  /* create the structure */
   if ((ct = (struct TAG_PKT *)malloc(sizeof(struct TAG_PKT))) == NULL) {
      status_display("Unable to aquire memory");
      scdmclose(cp->handle);
      free(cp);
      return(NULL);
    }

  /* initialize variables */
    ct->next_tag = NULL;

  /* get tag name & save */
    tag = ((xl+1) << 16) + cp->handle;
    if (scdmtinfo(tag,&tinfo) < SC_SUCCESS) {
      sprintf(tempstr,"Unable to get tag name for file %s",cp->handle);
      status_display(tempstr);
      scdmclose(cp->handle);
      free(cp);
      free(ct);
      return(NULL);
    }
    strcpy(ct->tag,tinfo.tname);

  /* open the tag */
    if (scdmtuse(&(ct->handle),cp->handle,ct->tag) < SC_SUCCESS) {
      sprintf(tempstr,"Unable to open %s file",ct->tag);
      status_display(tempstr);
      scdmclose(cp->handle);
      free(cp);
      free(ct);
      return(NULL);
    }
    scdmtinfo(ct->handle,&tinfo);
    ct->exprlen = tinfo.exprlen;

  /* allocate memory for a copy of the index expression */
    if ((xpr = (CHAR *)malloc(tinfo.exprlen+1)) == NULL) {
      status_display("Unable to allocate memory for index expression");
      scdmclose(cp->handle);
      free(cp);
      free(ct);
      return(NULL);
    }

  /* get a copy of the key expression */
    scdmtexpr(ct->handle,xpr);

  /* test for single field index */
    if (scddfnam2no(daccess->handle,&(ct->keytype),xpr) < SC_SUCCESS) {
      sceclr();
      ct->keytype = 'o';	/* compound key */
    }

  /* free memory */
    free(xpr);

  /* link tag into index */
    if (cp->first_tag == NULL)
      cp->first_tag = ct;
    else {
      tt = cp->first_tag;
      while (tt->next_tag != NULL) tt = tt->next_tag;
      tt->next_tag = ct;
    }
  }
#else
/* get & save some information about index file */
#ifdef DBASE3
  scdninfo(cp->handle,&info);
#endif
#ifdef FoxBASE
  scdiinfo(cp->handle,&info);
#endif
#ifdef Clipper
  scdcinfo(cp->handle,&info);
  cp->keydecpl = info.keydpl;
#endif
  cp->keylen = info.keylen;
  cp->exprlen = info.exprlen;

/* allocate memory for a copy of the index expression */
  if ((xpr = (CHAR *)malloc(info.exprlen+1)) == NULL) {
    status_display("Unable to allocate memory for index expression");
    CLOSE_INDEX;
    free(cp);
    return(NULL);
  }

/* get a copy of the key expression */
  INDEX_XPR;

/* test for single field index */
  if (scddfnam2no(daccess->handle,&(cp->keytype),xpr) < SC_SUCCESS) {
    sceclr();
    cp->keytype = 'o';	/* compound key */
  }

/* free memory */
  free(xpr);
#endif

  return(cp);
}  /* openindex */


/*******************************************************************
 **                                                               **
 **     Function:       sc_rlock                                  **
 **     Prototype:      INT sc_rlock(                             **
 **        struct DATA_PKT *,	pointer to data file packet       **
 **        LONG );		record number to lock             **
 **     Purpose:        To lock a data file record. 5 attempts    **
 **        will be made to lock the file before returning a       **
 **        failure.                                               **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
INT sc_rlock(struct DATA_PKT *daccess,
		LONG recno)
#else
INT sc_rlock(daccess,recno)
struct DATA_PKT *daccess;
LONG recno;
#endif
{
  INT count;

  count=1;
  do {
    savestat=scddrlock(daccess->handle,recno);
    sceclr();
  } while (count++ < 5 && savestat == SC_LCKVIOL);
  return(savestat);
}  /* sc_rlock */


/*******************************************************************
 **                                                               **
 **     Function:       sc_flock                                 **
 **     Prototype:      INT sc_flock(                            **
 **        struct DATA_PKT *);  pointer to data file packet       **
 **     Purpose:        To lock a data file. 5 attempts will be   **
 **        made to lock the file before returning a failure.      **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
INT sc_flock(struct DATA_PKT *daccess)
#else
INT sc_flock(daccess)
struct DATA_PKT *daccess;
#endif
{
  INT count;

  count=1;
  do {
    savestat=scddlock(daccess->handle);
    sceclr();
  } while (count++ < 5 && savestat == SC_LCKVIOL);
  return(savestat);
}  /* sc_flock */



/*******************************************************************
 **                                                               **
 **     Function:       sc_unlock                                 **
 **     Prototype:      INT sc_unlock(                            **
 **        struct DATA_PKT *);	pointer to data file packet       **
 **     Purpose:        To unlock an entire data file or a record.**
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
INT sc_unlock(struct DATA_PKT *daccess)
#else
INT sc_unlock(daccess)
struct DATA_PKT *daccess;
#endif
{
  savestat=scddunlock(daccess->handle);
  if (savestat != SC_SUCCESS)
    status_display("Unlock record failure");
  return(savestat);
}  /* sc_unlock */


/*******************************************************************
 **                                                               **
 **     Function:       read_field                                **
 **     Prototype:      INT read_field(                           **
 **        struct DATA_PKT *,	data file packet                  **
 **	   CHAR *,              data field name                   **
 **        CHAR *); 		buffer to copy data into          **
 **     Purpose:        To read a field from the data buffer.     **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
INT read_field(struct DATA_PKT *daccess,
	       CHAR *fldname,
	       CHAR *destin)
#else
INT read_field(daccess,fldname,destin)
struct DATA_PKT *daccess;
CHAR *fldname, *destin;
#endif
{
  if ((savestat = scddfnget(daccess->handle,destin,fldname)) != SC_SUCCESS) {
    status_display("Field name not found");
    return(scecode());
  }
  return(savestat);
}  /* read_field */



/*******************************************************************
 **                                                               **
 **     Function:       write_field_intct                         **
 **     Prototype:      INT write_field_intct(                    **
 **        struct DATA_PKT *,	data file packet                  **
 **	   CHAR *,              data field name                   **
 **        CHAR *); 		buffer to copy data from          **
 **     Purpose:        To write to a field in the data buffer    **
 **        without trimming leading spaces.                       **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
INT write_field_intct(struct DATA_PKT *daccess,
		      CHAR *fldname,
		      CHAR *dsource)
#else
INT write_field_intct(daccess, fldname,dsource)
struct DATA_PKT *daccess;
CHAR *fldname, *dsource;
#endif
{
  return(writefield(daccess,fldname,dsource,0));
}  /* write_field_intct */



/*******************************************************************
 **                                                               **
 **     Function:       sc_replace                               **
 **     Prototype:      INT sc_replace(                          **
 **        struct DATA_PKT *,	data file packet                  **
 **	   CHAR *,              data field name                   **
 **        CHAR *); 		buffer to copy data from          **
 **     Purpose:        To write to a field in the data buffer    **
 **        trimming leading spaces first.                         **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
INT sc_replace(struct DATA_PKT *daccess,
		CHAR *fldname,
		CHAR *dsource)
#else
INT sc_replace(daccess, fldname,dsource)
struct DATA_PKT *daccess;
CHAR *fldname, *dsource;
#endif
{
  return(writefield(daccess,fldname,dsource,LEFTJ));
}  /* sc_replace */



/*******************************************************************
 **                                                               **
 **     Function:       move_field                                **
 **     Prototype:      INT move_field(                           **
 **        struct DATA_PKT *,	data file packet                  **
 **	   CHAR *,              data field name                   **
 **        CHAR *, 		buffer to copy data from          **
 **        INT ); 		read or write field               **
 **     Purpose:        To read or write to a field in the data   **
 **        buffer.                                                **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
INT move_field(struct DATA_PKT *daccess,
		CHAR *fldname,
		CHAR *dsource,
		INT cmd)
#else
INT move_field(daccess, fldname,dsource,cmd)
struct DATA_PKT *daccess;
CHAR *fldname, *dsource;
INT cmd;
#endif
{
  INT a;

  if (cmd & WRITE)
    a = writefield(daccess,fldname,dsource,(cmd & LEFTJ));
  else
    a = read_field(daccess,fldname,dsource);
  return(a);
}  /* move_field */

/*******************************************************************
 **                                                               **
 **     Function:       writefield                                **
 **     Prototype:      static INT writefield(                    **
 **        struct DATA_PKT *,	data file packet                  **
 **	   CHAR *,              data field name                   **
 **        CHAR *, 		buffer to copy data from          **
 **        INT );		trim or not leading spaces        **
 **     Purpose:        To write to a field in the data buffer    **
 **        trimming (or not) leading spaces first.                **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
static INT writefield(struct DATA_PKT *daccess,
		CHAR *fldname,
		CHAR *dsource,
		INT cmd)
#else
static INT writefield(daccess, fldname, dsource, cmd)
struct DATA_PKT *daccess;
CHAR *fldname, *dsource;
INT cmd;
#endif
{
  if (cmd & LEFTJ)
    ltrim(dsource);
  if ((savestat = scddfnput(daccess->handle,dsource,fldname)) != SC_SUCCESS) {
    status_display("Field name not found");
    return(scecode());
  }
  return(savestat);
}  /* writefield */


/*******************************************************************
 **                                                               **
 **     Function:       sc_go                                     **
 **     Prototype:      INT sc_go(                                **
 **        struct DATA_PKT *,	data file packet                  **
 **        LONG );		record to read                    **
 **     Purpose:        To read a record in manual lock mode.     **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
INT sc_go(struct DATA_PKT *daccess,
	    LONG recno)
#else
INT sc_go(daccess,recno)
struct DATA_PKT *daccess;
LONG recno;
#endif
{
/* lock record */
  daccess->recno = recno;
  if (daccess->mode & SC_SHARED) {
    savestat= sc_rlock(daccess,recno);
    if (savestat != SC_SUCCESS) {
      status_display("recrec lock failed");
      return(savestat);
    }
  }

/* read record from file */
  savestat= scddrget(daccess->handle,recno);
  if (savestat != SC_SUCCESS)
    status_display("Read by record number failure");

/* unlock record */
  if (daccess->mode & SC_SHARED)
    savestat=sc_unlock(daccess);

  return(savestat);
}  /* sc_go */


/*******************************************************************
 **                                                               **
 **     Function:       sc_delete                                 **
 **     Prototype:      INT sc_delete(                            **
 **        struct DATA_PKT *,	data file packet                  **
 **        LONG );		record to inactivate              **
 **     Purpose:        To mark a record as inactive.             **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
INT sc_delete(struct DATA_PKT *daccess,
	    LONG recno)
#else
INT sc_delete(daccess,recno)
struct DATA_PKT *daccess;
LONG recno;
#endif
{
/* if running multi-user then lock record */
  if (daccess->mode & SC_SHARED) {
    savestat = sc_rlock(daccess,recno);
    if (savestat != SC_SUCCESS) {
      status_display("Delete lock failure");
      return(savestat);
    }
  }

/* delete record */
  if (scddrdel(daccess->handle,recno) < SC_SUCCESS)
    status_display("Logical delete record failure");
  if (scddflush(daccess->handle) < SC_SUCCESS)
    status_display("Flush failure");

/* if running multi-user then unlock record */
  if (daccess->mode & SC_SHARED) {
    savestat=sc_unlock(daccess);
    if (savestat != SC_SUCCESS)
      status_display("Delete unlock failure");
  }
  return(savestat);
}  /* sc_delete */


/*******************************************************************
 **                                                               **
 **     Function:       remove_keys                               **
 **     Prototype:      INT remove_keys(                          **
 **        struct DATA_PKT *,	data file packet                  **
 **        LONG);		record number to remove keys for  **
 **     Purpose:        To delete the key(s) for the desired 	  **
 **        record for all open indices.                           **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
INT remove_keys(struct DATA_PKT *daccess,
		LONG recno)
#else
INT remove_keys(daccess,recno)
struct DATA_PKT *daccess;
LONG recno;
#endif
{
  struct INDEX_PKT *cp;
  INT count;
  CHAR *key_pntr = NULL;
#ifdef DBASE4
  struct TAG_PKT *ct;
#endif

  if (recno == 0L)
    return(SC_SKFAIL);

/* lock file */
  if (daccess->mode &SC_SHARED) {
    savestat=sc_flock(daccess);
    if (savestat != SC_SUCCESS)
      return(savestat);
  }

  daccess->recno = recno;
/* read record from data file */
  savestat = scddrget(daccess->handle,daccess->recno);
  if (savestat != SC_SUCCESS) {
    status_display("DBF file append write failure");
    return(savestat);
  }

/* delete keys from index file(s) */
  cp=daccess->index;
#ifdef DBASE4
  ct = cp->first_tag;
#endif
  while (cp != NULL) {

  /* lock index file */
    if (cp->mode & SC_SHARED) {
      count = 0;
      do {
	savestat=LOCK_INDEX;
	sceclr();
      }
      while (count++ < 5 && savestat == SC_LCKVIOL);
      if (savestat != SC_SUCCESS)
	break;
    }

  /* make key */
    MAKE_KEY;

  /* delete key from file */
    savestat=DELETE_KEY;
    if (savestat != SC_SUCCESS) {
      status_display("index key delete failure");
      break;
    }

  /* unlock index file */
    if (cp->mode & SC_SHARED) {
      savestat = UNLOCK_INDEX;
      if (savestat != SC_SUCCESS) {
	status_display("index file unlock failure");
	break;
      }
    }

  /* free key memory */
    scmfree(key_pntr);
    key_pntr = NULL;

#ifdef DBASE4
  /* next tag */
    if ((ct = ct->next_tag) == NULL) {
    /* next index file */
      cp=cp->next_index;
      ct = cp->first_tag;
    }
#else
  /* next index file */
    cp=cp->next_index;
#endif
  }

/* free memory if neccessary */
  if (key_pntr != NULL )
    free(key_pntr);

/* unlock file */
  if (daccess->mode & SC_SHARED)
    if (scddunlock(daccess->handle) != SC_SUCCESS)
      status_display("can't unlock file");

  return(savestat);
}  /* remove_keys */


/*******************************************************************
 **                                                               **
 **     Function:       write_record                              **
 **     Prototype:      INT write_record(                         **
 **        struct DATA_PKT *,	data file packet                  **
 **        LONG);		record number to remove keys for  **
 **     Purpose:        To write a record from the data buffer.   **
 **        The record is appended if the record number passed is  **
 **        0, otherwise the record is updated. All open index     **
 **        files updated.                                         **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
INT write_record(struct DATA_PKT *daccess,
		 LONG recno)
#else
INT write_record(daccess,recno)
struct DATA_PKT *daccess;
LONG recno;
#endif
{
  struct INDEX_PKT *cp;
  INT count;
  CHAR *key_pntr = NULL;
#ifdef DBASE4
  struct TAG_PKT *ct;
#endif

/* lock file */
  if (daccess->mode &SC_SHARED) {
    savestat=sc_flock(daccess);
    if (savestat != SC_SUCCESS)
      return(savestat);
  }

  daccess->recno = recno;
  if (recno == 0L) {
  /* append record to end of data file */
    savestat = scddrput(daccess->handle,&daccess->recno,SC_ADD);
    if (savestat != SC_SUCCESS) {
      status_display("DBF file append write failure");
      return(savestat);
    }
  }
  else {
  /* update the record if neccessary */
    savestat=scddrput(daccess->handle,&recno,SC_UPDATE);
    if (savestat != SC_SUCCESS) {
      status_display("update record failure");
      return(savestat);
    }
  }

/* flush data file changes to disk */
  if (scddflush(daccess->handle) != SC_SUCCESS)
    status_display("Flush failure");

/* add keys to index file(s) */
  cp=daccess->index;
#ifdef DBASE4
  ct = cp->first_tag;
#endif
  while (cp != NULL) {

  /* lock index file */
    if (cp->mode & SC_SHARED) {
      count = 0;
      do {
	savestat=LOCK_INDEX;
	sceclr();
      }
      while (count++ < 5 && savestat == SC_LCKVIOL);
      if (savestat != SC_SUCCESS)
	break;
    }

  /* make key */
    MAKE_KEY;

  /* add key to file */
    savestat=ADD_KEY;
    if (savestat != SC_SUCCESS) {
      status_display("index key add failure");
      break;
    }

  /* unlock index file */
    if (cp->mode & SC_SHARED) {
      savestat= UNLOCK_INDEX;
      if (savestat != SC_SUCCESS) {
	status_display("index file unlock failure");
	break;
      }
    }

  /* free key memory */
    scmfree(key_pntr);
    key_pntr = NULL;

#ifdef DBASE4
  /* next tag */
    if ((ct = ct->next_tag) == NULL) {
    /* next index file */
      cp=cp->next_index;
      ct = cp->first_tag;
    }
#else
  /* next index file */
    cp=cp->next_index;
#endif
  }

/* free memory if neccessary */
  if (key_pntr != NULL )
    free(key_pntr);

/* unlock file */
  if (daccess->mode & SC_SHARED)
    if (scddunlock(daccess->handle) != SC_SUCCESS)
      status_display("can't unlock file");

  return(savestat);
}  /* write_record */

/*******************************************************************
 **                                                               **
 **     Function:       read_next_key                             **
 **     Prototype:      INT read_next_key(                        **
 **        struct DATA_PKT *,   data file packet                  **
 **	   CHAR *,              pointer to key                    **
 **        LONG *);		record number                     **
 **     Purpose:        To read the next key with manual locks.   **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
INT read_next_key(struct DATA_PKT *daccess,
		  CHAR *key_pntr,
		  LONG *recno)
#else
INT read_next_key(daccess,key_pntr,recno)
struct DATA_PKT *daccess;
CHAR *key_pntr;
LONG *recno;
#endif
{
  INT count = 0;
  struct INDEX_PKT *cp;
#ifdef DBASE4
  struct TAG_PKT *ct;
#endif

  cp = daccess->index;
#ifdef DBASE4
  ct = cp->first_tag;
#endif

/* lock the index file */
  do {
    savestat = LOCK_INDEX;
    sceclr();
  }
  while (count++ < 5 && savestat == SC_LCKVIOL);
  if (savestat != SC_SUCCESS) {
    status_display("next key err 1");
    return(savestat);
  }

/* read next key */
  savestat = NEXT_KEY;

/* unlock the index file */
  count = UNLOCK_INDEX;
  return(savestat);
}  /* read_next_key */


/*******************************************************************
 **                                                               **
 **     Function:       readnext                                  **
 **     Prototype:      INT readnext(                             **
 **        struct DATA_PKT *)	data file packet                  **
 **     Purpose:        To read the next record by key order.     **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
INT readnext(struct DATA_PKT *daccess)
#else
INT readnext(daccess)
struct DATA_PKT *daccess;
#endif
{
  CHAR keybuff[101];

/* read next key */
  savestat = read_next_key(daccess,keybuff,&daccess->recno);

/* read the record */
  savestat=sc_go(daccess,daccess->recno);
  return(savestat);
}  /* readnext */


/*******************************************************************
 **                                                               **
 **     Function:       read_prev_key                             **
 **     Prototype:      INT read_prev_key(                        **
 **        struct DATA_PKT *,   data file packet                  **
 **	   CHAR *,              pointer to key                    **
 **        LONG *);		record number                     **
 **     Purpose:        To read the previous key with manual 	  **
 **        locks.    						  **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
INT read_prev_key(struct DATA_PKT *daccess,
		  CHAR *key_pntr,
		  LONG *recno)
#else
INT read_prev_key(daccess,key_pntr,recno)
struct DATA_PKT *daccess;
CHAR *key_pntr;
LONG *recno;
#endif
{
  INT count = 0;
  struct INDEX_PKT *cp;
#ifdef DBASE4
  struct TAG_PKT *ct;
#endif

  cp = daccess->index;
#ifdef DBASE4
  ct = cp->first_tag;
#endif

/* lock the index file */
  do {
    savestat = LOCK_INDEX;
    sceclr();
  }
  while (count++ < 5 && savestat == SC_LCKVIOL);
  if (savestat != SC_SUCCESS) {
    status_display("prev key err 1");
    return(savestat);
  }

/* read previous key */
  savestat = PREVIOUS_KEY;

/* unlock the index file */
  count = UNLOCK_INDEX;
  return(savestat);
}  /* read_prev_key */


/*******************************************************************
 **                                                               **
 **     Function:       readprev                                  **
 **     Prototype:      INT readprev(                             **
 **        struct DATA_PKT *)	data file packet                  **
 **     Purpose:        To read the previous record by key order. **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
INT readprev(struct DATA_PKT *daccess)
#else
INT readprev(daccess)
struct DATA_PKT *daccess;
#endif
{
  CHAR keybuff[101];

/* read previous key */
  savestat = read_prev_key(daccess,keybuff,&daccess->recno);

/* read the record */
  savestat=sc_go(daccess,daccess->recno);
  return(savestat);
}  /* readprev */


/*******************************************************************
 **                                                               **
 **     Function:       read_key_equal                            **
 **     Prototype:      INT read_key_equal(                       **
 **        struct DATA_PKT *,	data file packet                  **
 **        CHAR *,		pointer to search key             **
 **        INT,                 trim spaces or not                **
 **	   INT			date style (date keys)            **
 **     Purpose:        To read the record pointed to by the key. **
 **                                                               **
 *******************************************************************/

#ifdef __ANSI_PROTOTYPES__
INT read_key_equal(struct DATA_PKT *daccess,
		   CHAR *key_pntr,
		   INT cmd,
		   INT datestyle)
#else
INT read_key_equal(daccess,key_pntr,cmd,datestyle)
struct DATA_PKT *daccess;
CHAR *key_pntr;
INT cmd;
INT datestyle;
#endif
{
  CHAR tempstring[8];
  INT count, save;
  struct INDEX_PKT *cp;
#ifdef DBASE4
  struct TAG_PKT *ct;
#endif

  cp = daccess->index;
#ifdef DBASE4
  ct = cp->first_tag;
#endif

/* build key */
#ifndef DBASE4
  switch(cp->keytype) {
#else
  switch(ct->keytype) {
#endif
    case 'D':
    case 'd':
      if ((savestat=MAKE_DKEY) != SC_SUCCESS) {
	status_display("ASCII to key failure");
	return(savestat);
      }
      break;
    case 'N':
    case 'n':
      if ((savestat=MAKE_NKEY) != SC_SUCCESS) {
	status_display("double to key failure");
	return(savestat);
      }
      break;
    case 'c':
    case 'C':
      if (cmd & LEFTJ)
	ltrim(tempstring);
      break;
    default:
      MAKE_KEY;
      break;
  }

/* lock index file */
  if (cp->mode & SC_SHARED) {
    count = 0;
    do {
      savestat=LOCK_INDEX;
      sceclr();
    }
    while (count++ < 5 && savestat == SC_LCKVIOL);
    if (savestat != SC_SUCCESS) {
      status_display("lock index failure");
      return(savestat);
    }
  }

/* find key */
  save=FIND_KEY;

/* unlock index file */
  if (cp->mode & SC_SHARED)
    count = UNLOCK_INDEX;
  if (save != SC_SUCCESS) {
    savestat = save;
    if (savestat != SC_NOFIND && savestat != SC_END)
      status_display("translate key to record number failure");
    return(savestat);
  }
  if (cp->mode & SC_SHARED) {
    savestat = count;
    if (savestat != SC_SUCCESS) {
      status_display("index file unlock failure");
      return(savestat);
    }
  }

/* read record from data file */
  if (sc_go(daccess,daccess->recno) != SC_SUCCESS)
    return(savestat);
  return(savestat = save);
}  /* read_key_equal */


